## ros-indigo-rail-object-detector 3.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(rail_object_detector)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  cv_bridge
  image_geometry
  image_transport
  rail_object_detection_msgs
  roscpp
  sensor_msgs
  std_msgs
  tf
)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS system)

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
catkin_python_setup()

################################################
## Declare ROS messages, services and actions ##
################################################

## To declare and build messages, services or actions from within this
## package, follow these steps:
## * Let MSG_DEP_SET be the set of packages whose message types you use in
##   your messages/services/actions (e.g. std_msgs, actionlib_msgs, ...).
## * In the file package.xml:
##   * add a build_depend tag for "message_generation"
##   * add a build_depend and a run_depend tag for each package in MSG_DEP_SET
##   * If MSG_DEP_SET isn't empty the following dependency has been pulled in
##     but can be declared for certainty nonetheless:
##     * add a run_depend tag for "message_runtime"
## * In this file (CMakeLists.txt):
##   * add "message_generation" and every package in MSG_DEP_SET to
##     find_package(catkin REQUIRED COMPONENTS ...)
##   * add "message_runtime" and every package in MSG_DEP_SET to
##     catkin_package(CATKIN_DEPENDS ...)
##   * uncomment the add_*_files sections below as needed
##     and list every .msg/.srv/.action file to be processed
##   * uncomment the generate_messages entry below
##   * add every package in MSG_DEP_SET to generate_messages(DEPENDENCIES ...)

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
#   Object.msg
#   Detections.msg
# )

## Generate services in the 'srv' folder
# add_service_files(
#   FILES
#   SceneQuery.srv
#   ImageQuery.srv
# )

## Generate added messages and services with any dependencies listed here
# generate_messages(
#   DEPENDENCIES
#   sensor_msgs
#   std_msgs
# )

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS
    include
#  LIBRARIES object_detector
  CATKIN_DEPENDS
    cv_bridge
    image_transport
    sensor_msgs
    rail_object_detection_msgs
#  DEPENDS system_lib
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
# include_directories(include)
include_directories(
  ${catkin_INCLUDE_DIRS}
  include
  libs/darknet/src
)

# Add the definitions for darknet
if(CMAKE_BUILD_TYPE MATCHES Debug|DEBUG|debug OR NOT CMAKE_BUILD_TYPE)
  set(DARKNET_DEBUG 1 CACHE INTERNAL "")
else()
  set(DARKNET_DEBUG 0 CACHE INTERNAL "")
endif()

if(DARKNET_GPU EQUAL 1 AND DEFINED DARKNET_GPU_ARCH)
  add_definitions(-DGPU=1)
endif()

## Declare the C based darknet library
add_custom_target(darknet ALL
  COMMAND GPU=${DARKNET_GPU} DEBUG=${DARKNET_DEBUG} GPU_ARCH=${DARKNET_GPU_ARCH} make library
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/libs/darknet
)

## Declare a C++ library
add_library(rail_darknet_detector
  src/darknet_detector.cpp
)

## Add cmake target dependencies of the library
## as an example, code may need to be generated before libraries
## either from message generation or dynamic reconfigure
add_dependencies(rail_darknet_detector
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
  darknet
)

## Declare a C++ executable
add_executable(darknet_node
  nodes/darknet_node.cpp
)

## Add cmake target dependencies of the executable
## same as for the library above
add_dependencies(darknet_node
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
  rail_darknet_detector
)

## Specify libraries to link a library or executable target against
if(DARKNET_GPU EQUAL 1 AND DEFINED DARKNET_GPU_ARCH)
  target_link_libraries(rail_darknet_detector
    ${catkin_LIBRARIES}
    ${PROJECT_SOURCE_DIR}/libs/darknet/libdarknet.a
    -L/usr/local/cuda/lib64
    -lcuda
    -lcudart
    -lcublas
    -lcurand
  )
else()
  target_link_libraries(rail_darknet_detector
    ${catkin_LIBRARIES}
    ${PROJECT_SOURCE_DIR}/libs/darknet/libdarknet.a
  )
endif()

target_link_libraries(darknet_node
  ${catkin_LIBRARIES}
  rail_darknet_detector
)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS darknet_node rail_darknet_detector
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Install the python scripts at the appropriate location
catkin_install_python(PROGRAMS nodes/drfcn_node
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  FILES_MATCHING PATTERN "*.launch"
)

install(DIRECTORY libs/darknet/cfg/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/libs/darknet/cfg
  FILES_MATCHING PATTERN "yolo.cfg"
)

install(DIRECTORY libs/darknet/data/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/libs/darknet/data
  FILES_MATCHING PATTERN "coco.names"
)

=== requirements.txt ===
Cython
EasyDict
mxnet-cu80
Pillow
pyyaml

=== libs/darknet/Makefile ===
# GPU is defined in CMakeLists
CUDNN=0
OPENCV=1
# DEBUG is defined in CMakeLists
# GPU_ARCH is defined in CMakeLists

ifdef GPU_ARCH
ARCH= --gpu-architecture=$(GPU_ARCH) --gpu-code=$(GPU_ARCH)
else
GPU=0
endif

VPATH=./src/
EXEC=darknet
LIB=libdarknet.a
OBJDIR=./obj/

AR=ar
CC=gcc
NVCC=nvcc 
OPTS=-Ofast
LDFLAGS= -lm -pthread 
COMMON= 
CFLAGS=-Wall -Wfatal-errors -fPIC

ifeq ($(DEBUG), 1) 
OPTS=-O0 -g
endif

CFLAGS+=$(OPTS)

ifeq ($(OPENCV), 1) 
COMMON+= -DOPENCV
CFLAGS+= -DOPENCV
LDFLAGS+= `pkg-config --libs opencv` 
COMMON+= `pkg-config --cflags opencv` 
endif

ifeq ($(GPU), 1) 
COMMON+= -DGPU -I/usr/local/cuda/include/
CFLAGS+= -DGPU
LDFLAGS+= -L/usr/local/cuda/lib64 -lcuda -lcudart -lcublas -lcurand
endif

ifeq ($(CUDNN), 1) 
COMMON+= -DCUDNN 
CFLAGS+= -DCUDNN
LDFLAGS+= -lcudnn
endif

OBJ=gemm.o utils.o cuda.o convolutional_layer.o list.o image.o activations.o im2col.o col2im.o blas.o crop_layer.o dropout_layer.o maxpool_layer.o softmax_layer.o data.o matrix.o network.o connected_layer.o cost_layer.o parser.o option_list.o darknet.o detection_layer.o captcha.o route_layer.o writing.o box.o nightmare.o normalization_layer.o avgpool_layer.o coco.o dice.o yolo.o detector.o layer.o compare.o classifier.o local_layer.o swag.o shortcut_layer.o activation_layer.o rnn_layer.o gru_layer.o rnn.o rnn_vid.o crnn_layer.o demo.o tag.o cifar.o go.o batchnorm_layer.o art.o region_layer.o reorg_layer.o super.o voxel.o tree.o
ifeq ($(GPU), 1) 
LDFLAGS+= -lstdc++ 
OBJ+=convolutional_kernels.o activation_kernels.o im2col_kernels.o col2im_kernels.o blas_kernels.o crop_layer_kernels.o dropout_layer_kernels.o maxpool_layer_kernels.o network_kernels.o avgpool_layer_kernels.o
endif

OBJS = $(addprefix $(OBJDIR), $(OBJ))
DEPS = $(wildcard src/*.h) Makefile

$(LIB): $(OBJS)
	$(AR) rcs $@ $^

library: obj $(LIB)

all: obj backup results $(EXEC)

$(EXEC): $(OBJS)
	$(CC) $(COMMON) $(CFLAGS) $^ -o $@ $(LDFLAGS)

$(OBJDIR)%.o: %.c $(DEPS)
	$(CC) $(COMMON) $(CFLAGS) -c $< -o $@

$(OBJDIR)%.o: %.cu $(DEPS)
	$(NVCC) $(ARCH) $(COMMON) --compiler-options "$(CFLAGS)" -c $< -o $@

obj:
	mkdir -p obj
backup:
	mkdir -p backup
results:
	mkdir -p results

.PHONY: clean

clean:
	rm -rf $(OBJS) $(EXEC) $(LIB)

=== debian/changelog ===
ros-indigo-rail-object-detector (3.0.2-0trusty) trusty; urgency=high

  * Update the default branch

 -- Siddhartha Banerjee <banerjs.sid@gmail.com>  Thu, 01 Nov 2018 04:00:00 -0000

ros-indigo-rail-object-detector (3.0.1-0trusty) trusty; urgency=high

  * Create a separate package for the messages
  * Contributors: Siddhartha Banerjee, banerjs

 -- Siddhartha Banerjee <banerjs.sid@gmail.com>  Fri, 07 Sep 2018 04:00:00 -0000

ros-indigo-rail-object-detector (2.0.1-0trusty) trusty; urgency=high

  * Added Deformable RFCN detector.
  * Change darknet node name.
  * Change directory structure and file names for darknet.
  * Update README with valid weights file, and fix broken links
  * Contributors: Andrew Silva, Ryan Petschek, Siddhartha Banerjee, Weiyu Liu

 -- Siddhartha Banerjee <banerjs.sid@gmail.com>  Mon, 11 Dec 2017 05:00:00 -0000

ros-indigo-rail-object-detector (1.0.4-0trusty) trusty; urgency=high

  * Adding in an automatic build for 32 bit
  * Contributors: Siddhartha Banerjee, banerjs

 -- Siddhartha Banerjee <banerjs.sid@gmail.com>  Thu, 09 Feb 2017 05:00:00 -0000

ros-indigo-rail-object-detector (1.0.3-0trusty) trusty; urgency=high

  * Adding in base travis build
  * Fixed the 32-bit compile error, hopefully
  * Contributors: Siddhartha Banerjee

 -- Siddhartha Banerjee <banerjs.sid@gmail.com>  Thu, 09 Feb 2017 05:00:00 -0000

ros-indigo-rail-object-detector (1.0.2-0trusty) trusty; urgency=high

  * Completed the build of GPU with flags
  * Pushing fixes in master back to gpu_devel. Merge branch 'master' into gpu_devel
  * Updated the README. Unfortunately, the mangling of data between publisher and service still exists and I cannot get rid of it
  * Fixed timing bugs with the object detector and possibly even the bug between service and topic contention. Need to test
  * Merging updates on master into the GPU branch
  * Created and Tested install of the package
  * Removed the need to update internal config file values
  * Returning defaults
  * Changed naming for a public release.
  * Testing out GPU functionality
  * Adding in a gitignore
  * Updated the detector to also use a topic for publishing object detections
  * removed unused parameters
  * removed service name parameter
  * Updated path in test script to use package-based absolute path
  * package-location-based absolute paths for ros params, minor cleanup and debugging, documentation
  * Adding in the cfg and data folders
  * Completed final details on object detection. Delivering project for now
  * Cursory stress test of the node is complete
  * Finally done with a functioning prototype of the object detector
  * Successful linkage of C++ with C
  * Completed ROS Skeleton for the detector
  * Initial commit of the object detector
  * Contributors: David Kent, Siddhartha Banerjee

 -- Siddhartha Banerjee <banerjs.sid@gmail.com>  Fri, 03 Feb 2017 05:00:00 -0000

=== debian/control ===
Source: ros-indigo-rail-object-detector
Section: misc
Priority: extra
Maintainer: Siddhartha Banerjee <banerjs.sid@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-cv-bridge, ros-indigo-image-geometry, ros-indigo-image-transport, ros-indigo-rail-object-detection-msgs, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-rail-object-detector
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-cv-bridge, ros-indigo-image-geometry, ros-indigo-image-transport, ros-indigo-rail-object-detection-msgs, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf
Description: The rail_object_detector package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-rail-object-detector//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
